#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ============================================================================= 
# Copyright (c) Ostap developpers.
# ============================================================================= 
## @file ostap/math/tests/test_math_ve.py
#  Test module for the file ostap/math/ve.py
# ============================================================================= 
""" Test module for ostap/math/ve.py
"""
# ============================================================================= 
from ostap.math.ve      import VE
# =============================================================================     
# logging 
# ============================================================================= 
from ostap.logger.logger import getLogger
if '__main__' ==  __name__ : logger = getLogger ( 'test_math_ve' )
else                       : logger = getLogger ( __name__  )
# ============================================================================= 

def test_ve():
    
    a = VE(100,100)
    b = VE(400,400)
    
    assert ( (a+b).value() == 500           )
    assert ( (b-a).value() == 300           )
    assert ( (a+b).error() == (a-b).error() ) 
    
# =============================================================================
if '__main__' == __name__ :

    test_ve()
    
# =============================================================================
##                                                                      The END 
# =============================================================================
