// ============================================================================
#ifndef OSTAP_OSTAP_H 
#define OSTAP_OSTAP_H 1
// ============================================================================
// Include files
// ============================================================================
#include "Ostap/AddVars.h"
#include "Ostap/BSpline.h"
#include "Ostap/BLOB.h"
#include "Ostap/Bernstein.h"
#include "Ostap/Bernstein1D.h"
#include "Ostap/Bernstein2D.h"
#include "Ostap/Bernstein3D.h"
#include "Ostap/Binomial.h"
#include "Ostap/Bit.h"
#include "Ostap/Chi2Fit.h"
#include "Ostap/Chi2Solution.h"
#include "Ostap/Clenshaw.h"
#include "Ostap/Choose.h"
#include "Ostap/Combine.h"
#include "Ostap/DalitzIntegrator.h"
#include "Ostap/Digit.h"
#include "Ostap/Differences.h"
#include "Ostap/EigenSystem.h"
#include "Ostap/Formula.h"
#include "Ostap/Fourier.h"
#include "Ostap/GenericMatrixTypes.h"
#include "Ostap/GenericVectorTypes.h"
#include "Ostap/GSL_utils.h"
#include "Ostap/Hesse.h"
#include "Ostap/HistoDump.h"
#include "Ostap/HistoInterpolation.h"
#include "Ostap/HistoMake.h"
#include "Ostap/HistoProject.h"
#include "Ostap/HistoStat.h"
#include "Ostap/KramersKronig.h"
#include "Ostap/Integrator.h"
#include "Ostap/Interpolation.h"
#include "Ostap/Line.h"
#include "Ostap/LineTypes.h"
#include "Ostap/Lomont.h"
#include "Ostap/LorentzVectorWithError.h"
#include "Ostap/Kinematics.h"
#include "Ostap/Math.h"
#include "Ostap/MatrixUtils.h"
#include "Ostap/MatrixTransforms.h"
#include "Ostap/Models.h"
#include "Ostap/Models2D.h"
#include "Ostap/Moments.h"
#include "Ostap/MoreMath.h"
#include "Ostap/MoreRooFit.h"
#include "Ostap/MoreVars.h"
#include "Ostap/Mute.h"
#include "Ostap/NSphere.h"
#include "Ostap/NStatEntity.h"
#include "Ostap/Peaks.h"
#include "Ostap/Primitives.h"
#include "Ostap/Point3DTypes.h"
#include "Ostap/Point3DWithError.h"
#include "Ostap/Polynomials.h"
#include "Ostap/Power.h"
#include "Ostap/PyIterator.h"
#include "Ostap/PySelector.h"
#include "Ostap/PySelectorWithCuts.h"
#include "Ostap/Polarization.h"
#include "Ostap/SFactor.h"
#include "Ostap/StatEntity.h"
#include "Ostap/StatVar.h"
#include "Ostap/StatusCode.h"
#include "Ostap/SVectorWithError.h"
#include "Ostap/SymmetricMatrixTypes.h"
#include "Ostap/Tee.h"
#include "Ostap/ToStream.h"
#include "Ostap/TypeWrapper.h"
#include "Ostap/Valid.h"
#include "Ostap/ValueWithError.h"
#include "Ostap/Vector3DTypes.h"
#include "Ostap/Vector3DWithError.h"
#include "Ostap/Vector4DTypes.h"
#include "Ostap/UStat.h"
#include "Ostap/WStatEntity.h"
// ============================================================================
/** @namespace Ostap Ostap/Ostap.h
 *  The main namespace to keep all Ostap code 
 */
namespace Ostap
{
  // ==========================================================================
} // The end of namespace Ostap
// ============================================================================
//                                                                      The END 
// ============================================================================
#endif // OSTAP_OSTAP_H
// ============================================================================
