// ============================================================================
// Incldue files 
// ============================================================================
// STD&STL
// ============================================================================
#include <memory>
#include <cstring>
// ============================================================================
// Ostap 
// ============================================================================
#include "Ostap/BLOB.h"
// ============================================================================
/** @file 
 *  Implementation file for class Ostap::BLOB
 *  @see Ostap::BLOB
 *  @date 2019-04-24 
 *  @author Vanya BELYAEV Ivan.Belyaev@itep.ru
 */
// ============================================================================
// Standard constructor
// ============================================================================
Ostap::BLOB::BLOB
( const std::string& name   , 
  const std::string& title  ,
  const std::size_t  len    , 
  const void*        buffer ) 
  : TNamed ( name , title ) 
  , m_data () 
{
  if  ( 0 !=  len ) 
  {
    char* data = new char[len] ;
    std::memcpy ( data , buffer , len ) ;
    m_data.Adopt ( len , data ) ;  
  }
}
// ============================================================================
// destructor 
// ============================================================================
Ostap::BLOB::~BLOB(){}
// ============================================================================
// redefine the buffer 
// ============================================================================
void Ostap::BLOB::setBuffer ( const std::size_t size   , 
                              const void*       buffer ) 
{ m_data.Set ( size , (const char*) buffer ) ; }

// ============================================================================
//                                                                      The END 
// ============================================================================

